<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1300">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon
            color="deep-orange accent-4

"
          >
            mdi-chart-areaspline
          </v-icon>

          Seguimiento
        </v-btn>
      </template>

      <v-card :class="'modalSystem'">
        <v-btn icon right @click="dialog = false" class="float-right">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-card>
          <h3 class="text-center">SEGUIMIENTO DE SATISFACCIÓN</h3>
          <h4 class="text-center font-weight-regular">
            Ingresa nuevo Seguimiento
          </h4>

          <div class="container">
            <v-simple-table class="table mt-2" fixed-header scrollable>
              <template>
                <thead>
                  <tr>
                    <th class="text-center" rowspan="2" width="120">
                      Mes / Año
                    </th>
                    <th class="text-center" colspan="3">NPS</th>
                    <th class="text-center" colspan="3">MTBF</th>
                    <th class="text-center" colspan="2">Optimización</th>
                    <th class="text-center" colspan="5">Tasa de Resolución</th>
                    <th class="text-center" rowspan="2" width="150">
                      Acciones
                    </th>
                  </tr>
                  <tr>
                    <th class="text-center" scope="col">Promotores</th>
                    <th class="text-center" scope="col">Neutros</th>
                    <th class="text-center" scope="col">Detractores</th>
                    <th class="text-center" scope="col">Toma de Decisiones</th>
                    <th class="text-center" scope="col">Cliente Externo</th>
                    <th class="text-center" scope="col">Cliente Interno</th>
                    <th class="text-center" scope="col">
                      Rentabilidad por Optimización
                    </th>
                    <th class="text-center" scope="col">Reducción de Costo</th>
                    <th class="text-center" scope="col">
                      Resueltos Autoservicio
                    </th>
                    <th class="text-center" scope="col">Resuelto N1</th>
                    <th class="text-center" scope="col">Resuelto N2</th>
                    <th class="text-center" scope="col">Resuelto N3</th>
                    <th class="text-center" scope="col">No Resueltos</th>
                  </tr>
                </thead>
                <tbody>
                  <template
                    :v-if="items.length > 0"
                    v-for="(item, index) in items"
                  >
                    <tr
                      :key="index"
                      :class="item.isVisible ? activeClass : hidden"
                      class="edit_row"
                      style="border-bottom: thin solid rgba(0, 0, 0, 0.12)"
                    >
                      <td class="text-center">
                        <v-menu
                          ref="menu"
                          v-model="menu"
                          :close-on-content-click="true"
                          :return-value.sync="date"
                          transition="scale-transition"
                          offset-y
                          max-width="290px"
                          min-width="auto"
                        >
                          <template v-slot:activator="{ on, attrs }">
                            <v-text-field
                              v-model="item.date"
                              label="Mes / Año"
                              prepend-icon="mdi-calendar"
                              readonly
                              outlined
                              v-bind="attrs"
                              v-on="on"
                            ></v-text-field>
                          </template>
                          <v-date-picker
                            v-model="item.date"
                            type="month"
                            no-title
                            scrollable
                          >
                          </v-date-picker>
                        </v-menu>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.promotores"
                          label="Promotores"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.neutros"
                          label="Neutros"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.detractores"
                          label="Detractores"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.decisiones"
                          label="Toma de Decisiones"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.clienteExterno"
                          label="Cliente Externo"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.clienteInterno"
                          label="Cliente Interno"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.rentOptimizacion"
                          label="Rentabilidad por Optimización"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.reduCostos"
                          label="Reducción de Costos"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.resueltoAuto"
                          label="Resuelto Autoservicio"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.resuelto1"
                          label="Resuelto N1"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.resuelto2"
                          label="Resuelto N2"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.resuelto3"
                          label="Resuelto N3"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.noResuelto"
                          label="No Resuelto"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center buttons">
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="primary"
                              class="edit"
                              @click="saveItem(item)"
                              v-bind="attrs"
                              v-on="on"
                            >
                              <v-icon>edit</v-icon>
                            </v-btn>
                          </template>
                          <span>Editar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="primary"
                              class="save"
                              @click="saveItem(item)"
                              v-bind="attrs"
                              v-on="on"
                            >
                              <v-icon>save</v-icon>
                            </v-btn>
                          </template>
                          <span>Guardar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="error"
                              v-bind="attrs"
                              v-on="on"
                              @click="removeItem()"
                            >
                              <v-icon>delete</v-icon>
                            </v-btn>
                          </template>
                          <span>Eliminar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="green"
                              v-bind="attrs"
                              v-on="on"
                              @click="isShow = !isShow"
                            >
                              <v-icon>mdi-eye</v-icon>
                            </v-btn>
                          </template>
                          <span>Ver detalles</span>
                        </v-tooltip>
                      </td>
                    </tr>
                  </template>
                </tbody>
              </template>
            </v-simple-table>
            <v-row>
              <v-col md="12" class="justify-center">
                <div class="btn d-flex justify-center mt-6">
                  <v-btn
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      justify-center
                    "
                    outlined
                    color="indigo lighten-2"
                    @click="AddItem()"
                  >
                    <v-icon color="purple">mdi-plus</v-icon>
                    Agregar otro
                  </v-btn>
                </div>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data: () => ({
    dialog: false,
    items: [
      {
        date: new Date().toISOString().substr(0, 7),
        neutros: 0,
        detractores: 0,
        decisiones: 0,
        promotores: 0,
        clienteInterno: 0,
        clienteExterno: 0,
        rentOptimizacion: 0,
        reduCostos: 0,
        resueltoAuto: 0,
        resuelto1: 0,
        resuelto2: 0,
        resuelto3: 0,
        noResuelto: 0,
      },
    ],
    nameRules: [
      (v) => !!v || "Requerido.",
      (v) => v.length <= 15 || "Máximo 15 carácteres.",
    ],
    menu: false,
    isVisible: false,
    activeClass: "is-visible",
    isShow: true,
  }),
  methods: {
    AddItem() {
      this.items.push({
        anio: this.anio,
        mes: this.mes,
        costo: this.costo,
        total: this.total,
        monto: this.monto,
      });
    },
    removeItem() {
      if (this.items.length > 1) {
        this.items.splice(this.items, 1);
      }
    },
    saveItem(item) {
      item.isVisible = !item.isVisible;
      this.$forceUpdate();
    },
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.modalSystem .v-data-table__wrapper > table {
  min-width: 1600px;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.formSeg .formRow {
  display: none;
}
.formSeg .formRow:last-child {
  display: flex;
}
.edit_row
  .v-input.v-input--is-label-active.v-input--is-dirty.theme--light.v-text-field.v-text-field--is-booted.v-text-field--enclosed.v-text-field--outlined
  .v-input__prepend-outer {
  display: none;
}
.v-data-table__wrapper .edit_row th.text-center {
  color: rgba(0, 0, 0, 0.6);
}
.edit_row .v-text-field--outlined .v-input__prepend-outer {
  display: none !important;
}
</style>
